# -*-coding:utf-8 -*- #
# ---------------------------------------------------------------------------
# ProjectName:   pythonProject
# FileName:      db_sql.py
# Author:       xxxxxxx
# Datetime:     2023/8/5 13:59
# Description:
# 
# ---------------------------------------------------------------------------
"""
连接数据库的流程
    一：构造方法
        1.从ini文件中获取连接的信息
        2.创建连接对象
        3.使用连接对象创建游标对象
    二：
"""
import pymysql

from interface_接口优化2.data_extraction.read_excel import ReadExcel
from interface_接口优化2.data_extraction.read_ini import ReadIni


class DB:

    def __init__(self):
        read_ini = ReadIni()
        self.read_excel = ReadExcel()

        host = read_ini.read_sql("host")
        port = read_ini.read_sql("port")
        user = read_ini.read_sql("user")
        password = read_ini.read_sql("password")
        database = read_ini.read_sql("database")

        self.con = pymysql.connect(host=host, port=int(port), user=user, password=password, database=database, charset='utf8')
        self.yb = self.con.cursor()

    def delete_sql(self, sql_data):
        self.yb.execute(sql_data)
        self.con.commit()

    def select_sql(self, sql_data):
        self.yb.execute(sql_data)
        result = self.yb.fetchall()
        return result[0][0]


if __name__ == '__main__':
    db = DB()
    print(db.select_sql("""SELECT ID_ FROM uc_demension WHERE `CODE_`="test56_dem";"""))
