# -*-coding:utf-8 -*- #
# ---------------------------------------------------------------------------
# ProjectName:   pythonProject
# FileName:      test_execute_request.py
# Author:       xxxxxxx
# Datetime:     2023/8/5 17:05
# Description:
# 
# ---------------------------------------------------------------------------
"""
流程：
    1.创建一个装饰器，用来生成一个请求类对象，在请求前先获取所需要的数据，再进行请求
    2.创建一个装饰器，用来生成一个读取excel的类对象，用于判断执行sql语句，将需要的值更新到json文件中去
    3.判断如果需要先删除数据库，就先删除再执行请求
    4.判断如果需要先查询一个结果更新到json文件中，就先执行sql语句，更新到文件中，再执行请求
    5.判断不需要数据库操作，则直接执行请求
    6.判断啊如果又需要删除和查询的操作
"""
import logging

import pytest
from interface_接口优化2.data_extraction.read_excel import ReadExcel
import allure


@allure.epic("BPM系统")
class TestBPM:

    @pytest.mark.parametrize("mokuai_data, jk_data, title_data, level_data, method_data, mime_data, url_data, "
                             "case_data, expect_data, sql_type,"" sql_data, update_key", ReadExcel().all_data())
    def test_request(self, req_fix, db_fix, mokuai_data, jk_data, title_data, level_data, method_data, mime_data,
                     url_data, case_data, expect_data, sql_type, sql_data, update_key):
        allure.dynamic.feature(mokuai_data)
        allure.dynamic.story(jk_data)
        allure.dynamic.title(title_data)
        allure.dynamic.severity(level_data)
        if sql_type is None:
            result = req_fix.all_request(method=method_data, url=url_data, mime=mime_data, data=case_data)

        elif sql_type == "delete":
            db_fix.delete_sql(sql_data)
            result = req_fix.all_request(method=method_data, url=url_data, mime=mime_data, data=case_data)

        elif sql_type == "select":
            re = db_fix.select_sql(sql_data)
            case_data[update_key] = re
            result = req_fix.all_request(method=method_data, url=url_data, mime=mime_data, data=case_data)

        elif sql_type == "delete|select" or sql_type == "select|delete":
            db_fix.delete_sql(sql_data["delete"])

            re = db_fix.select_sql(sql_data["select"])
            case_data[update_key] = re
            result = req_fix.all_request(method=method_data, url=url_data, mime=mime_data, data=case_data)

        else:
            result = req_fix.request_all(method=method_data, url=url_data, mime=mime_data, case_data=case_data)

        try:
            for key in expect_data:
                assert expect_data[key] == result.json().get(key)

        except:
            logging.error("日志信息："'模块名称为 {}, 接口名称为 {}, 用例级别为 {}, 输入的数据为 {}, 期望结果为 {}, 实际结果为 {}'
                          .format(mokuai_data, jk_data, level_data, case_data, expect_data, result.json()))
            raise AssertionError("断言失败")
        else:
            print("断言成功")


if __name__ == '__main__':
    pytest.main()
